import { jsxs, jsx } from 'react/jsx-runtime';
import { FormInput, Button } from '@cpchain-foundation/ui';
import React from 'react';

function AddUrl({ onCancel, onConfirm, title }) {
    const [url, setUrl] = React.useState("");
    return (jsxs("div", { className: "bg-gray-100 py-4 px-3 flex flex-col", children: [jsx("h3", { className: "border-b pb-2 border-gray-200 text-lg", children: title }), jsx("div", { className: "flex flex-col py-4 gap-2", children: jsx(FormInput, { label: "Url:", placeholder: "Enter url", onChange: (v) => setUrl(v) }) }), jsxs("div", { className: "flex flex-row justify-end gap-2 items-center", children: [jsx("div", { onClick: () => {
                            onCancel();
                        }, className: "text-gray-400 cursor-pointer", children: "Cancel" }), jsx(Button, { disabled: !url, onClick: () => {
                            onConfirm(url);
                        }, children: "Confirm" })] })] }));
}

export { AddUrl };
