import { jsx, jsxs } from 'react/jsx-runtime';
import { useState, useEffect } from 'react';
import Skeleton from 'react-loading-skeleton';

function Image({ selected, src, onClick }) {
    return jsxs("div", { className: "my-4 relative shadow-md", children: [selected && jsx("i", { className: "icon-check-circle text-3xl text-green-500 absolute" }), jsx("img", { className: "w-40 object-contain ", onClick: () => { onClick(); }, src: src, alt: "" })] });
}
function ImageHolder() {
    return jsx("div", { className: "w-40 h-405", children: jsx(Skeleton, { count: 5, className: "h-40 my-3" }) });
}
function ImageViewer({ images, onSelect, loading }) {
    const [img, setImg] = useState([]);
    const columns = [1, 2, 3, 4];
    useEffect(() => {
        setImg(images.map(p => { return { src: p, selected: false }; }));
    }, [images]);
    if (loading) {
        return jsx("div", { className: "w-224 h-96 overflow-y-auto flex-row flex overflow-hidden gap-4", children: columns.map((p) => jsx(ImageHolder, {}, p)) });
    }
    return jsx("div", { className: "w-224 h-96 overflow-y-auto overflow-hidden", children: jsx("ul", { className: "columns-4 gap-4", children: img.map((p, i) => {
                return jsx("li", { className: " break-inside-avoid", children: jsx(Image, { onClick: () => {
                            p.selected = !p.selected;
                            setImg([...img]);
                            onSelect(img.filter(p => p.selected).map(p => p.src));
                        }, src: p.src, selected: p.selected }) }, i);
            }) }) });
}

export { ImageViewer };
