import { createCommand, ElementNode } from 'lexical';

function convertVideoElement(element) {
    const nodeName = element.nodeName.toLowerCase();
    let node = null;
    if (nodeName === 'video') {
        node = $createVideoNode(element.src);
    }
    return { node };
}
class VideoNode extends ElementNode {
    static getType() {
        return 'video';
    }
    static clone(node) {
        return new VideoNode(node.__url, node.__key);
    }
    constructor(url, key) {
        super(key);
        this.__url = url;
    }
    createDOM(config) {
        const x = document.createElement('video');
        x.setAttribute("controls", "controls");
        x.setAttribute("src", this.__url);
        return x;
    }
    static importDOM() {
        return {
            video: (node) => ({
                conversion: convertVideoElement,
                priority: 0,
            }),
        };
    }
    updateDOM() {
        return false;
    }
    setURL(url) {
        const writable = this.getWritable();
        writable.__url = url;
    }
    exportJSON() {
        throw new Error("Method not implemented.");
    }
    static importJSON(_serializedNode) {
        throw new Error("Method not implemented.");
    }
}
function $createVideoNode(url) {
    return new VideoNode(url);
}
const INSERT_VIDEO_COMMAND = createCommand('INSERT_VIDEO_COMMAND');

export { $createVideoNode, INSERT_VIDEO_COMMAND, VideoNode };
