import { useLexicalComposerContext } from '@lexical/react/LexicalComposerContext';
import { $getRoot, $insertNodes } from 'lexical';
import { useEffect } from 'react';
import { L as LexicalHtml_1 } from '../../node_modules/@lexical/html/LexicalHtml.js';

function InitialWithHtmlPlugin({ html: initHtml = '' }) {
    const [editor] = useLexicalComposerContext();
    useEffect(() => {
        if (initHtml) {
            const parser = new DOMParser();
            const dom = parser.parseFromString(initHtml, 'text/html');
            editor.update(() => {
                const nodes = LexicalHtml_1.$generateNodesFromDOM(editor, dom);
                $getRoot().select();
                $insertNodes(nodes);
            });
        }
    }, [editor, initHtml]);
    return null;
}

export { InitialWithHtmlPlugin };
