import { useLexicalComposerContext } from '@lexical/react/LexicalComposerContext';
import { $insertNodes } from 'lexical';
import { useEffect } from 'react';
import { INSERT_VIDEO_COMMAND, $createVideoNode } from '../nodes/video.js';

function VideoPlugin() {
    const [editor] = useLexicalComposerContext();
    useEffect(() => {
        // Similar with command listener, which returns unlisten callback
        const removeListener = editor.registerCommand(INSERT_VIDEO_COMMAND, (payload) => {
            // Adding custom command that will be handled by this plugin
            editor.update(() => {
                $insertNodes([$createVideoNode(payload)], true);
            });
            // Returning true indicates that command is handled and no further propagation is required
            return true;
        }, 0);
        return () => {
            removeListener();
        };
    }, [editor]);
    return null;
}

export { VideoPlugin };
